/**
 * Created by IntelliJ IDEA.
 * User: tchuong
 * Date: Feb 18, 2004
 * Time: 2:12:34 PM
 * To change this template use Options | File Templates.
 */
package j3d.examples.cube.gui;
// j3d.cube.gui.Main

import com.sun.j3d.utils.behaviors.keyboard.KeyNavigatorBehavior;
import com.sun.j3d.utils.geometry.ColorCube;
import com.sun.j3d.utils.universe.SimpleUniverse;
import com.sun.j3d.utils.universe.ViewingPlatform;
import gui.ClosableJFrame;
import gui.run.RunButton;
import j3d.utils.Gutils;
import j3d.utils.DoomKeyboard;
import j3d.utils.DoomKeyboard;

import javax.media.j3d.*;
import javax.swing.*;
import javax.vecmath.Point3d;
import java.awt.*;
import java.util.Enumeration;

public class Main {
    public static void main(String[] args) {
        ClosableJFrame cubeFrame = new ClosableJFrame("3d Cube");
        Container c = cubeFrame.getContentPane();
        c.setLayout(new BorderLayout());
        CubePanel cp = new CubePanel();
        ButtonControlPanel bcp = new ButtonControlPanel(cp);
        c.add(cp, BorderLayout.CENTER);
        c.add(bcp, BorderLayout.SOUTH);
        cubeFrame.setSize(600, 600);
        cubeFrame.show();
    }
}//Hello3dFrame

class CubePanel extends JPanel {
    public long alphaTime = 4000;
    public float cubeSize = 0.4f;

    public CubePanel() {
        setLayout(new BorderLayout());

        Canvas3D canvas3D = Gutils.getCanvas3D(this);
        add("Center", canvas3D);

        BranchGroup bg = createSceneGraph();
        SimpleUniverse su = new SimpleUniverse(canvas3D);
        ViewingPlatform vp = su.getViewingPlatform();
        vp.setNominalViewingTransform();
        TransformGroup tg = vp.getViewPlatformTransform();
        //PlatformGeometry pg = new PlatformGeometry();
        //pg.addChild(Shapes.getHousesBranchGroup());
        vp.setPlatformGeometry(DoomKeyboard.buildGunPlatform());
        TransformGroup steerTg = vp.getViewPlatformTransform();

        Transform3D t3d = new Transform3D();
        steerTg.getTransform(t3d);
        System.out.println(t3d);

        KeyNavigatorBehavior keyNavBeh = new GunFiredKeyboardNavigator(tg);
        //KeyBehavior keyNavBeh = new KeyBehavior(tg);
        keyNavBeh.setSchedulingBounds(new BoundingSphere(new Point3d(), 10000.0));
        bg.addChild(keyNavBeh);
        su.addBranchGraph(bg);
    }

    public BranchGroup createSceneGraph() {
        BranchGroup branchGroupRoot
                = Gutils.getBranchGroup();
        Transform3D rotate
                = new Transform3D();
        Transform3D tempRotate
                = new Transform3D();
        rotate.rotX(Math.PI / 4.0d);
        tempRotate.rotY(Math.PI / 5.0d);
        rotate.mul(tempRotate);

        TransformGroup rotateTransformGroup
                = Gutils.getTransformGroup(rotate);
        TransformGroup spinTransformGroup
                = Gutils.getTransformGroup();

        branchGroupRoot.addChild(rotateTransformGroup);
        rotateTransformGroup.addChild(spinTransformGroup);

        // Create a simple shape leaf node, add it to the scene graph.
        // ColorCube is a Convenience Utility
        cc = getColorCube();
        spinTransformGroup.addChild(cc);

        // Create a new Behavior object that will perform the desired
        // operation on the specified transform object and add it into
        // the scene graph.

        ri = getRotationInterpolator(spinTransformGroup);
        si = getScaleInterpolator(spinTransformGroup);
        BoundingSphere bounds = new BoundingSphere();
        ri.setSchedulingBounds(bounds);
        si.setSchedulingBounds(bounds);
        spinTransformGroup.addChild(ri);
        spinTransformGroup.addChild(si);
        return branchGroupRoot;
    }

    ColorCube cc = new ColorCube();

    private ColorCube getColorCube() {
        return new ColorCube(getCubeScale());
    }

    public void setCubeSize(float s) {
        si.setMinimumScale(s);
        si.setMaximumScale(s);
        cubeSize = s;
    }

    public float getCubeScale() {
        return cubeSize;
    }

    RotationInterpolator ri = null;
    ScaleInterpolator si = null;


    private ScaleInterpolator getScaleInterpolator(TransformGroup tg) {
        return new ScaleInterpolator(new Alpha(-1, getAlphaTime()),
                tg,
                new Transform3D(),
                0.0f,
                1f);
    }

    private RotationInterpolator getRotationInterpolator(TransformGroup objSpin) {
        return new RotationInterpolator(new Alpha(-1, getAlphaTime()),
                objSpin,
                new Transform3D(),
                0.0f,
                (float) Math.PI * 2.0f);
    }

    public void setAlphaTime(long num2) {
        alphaTime = num2;
        ri.setAlpha(new Alpha(-1, getAlphaTime()));
    }//setAlphaTime(int)

    public long getAlphaTime() {
        return alphaTime;
    }

    private static class GunFiredKeyboardNavigator extends KeyNavigatorBehavior {
        public GunFiredKeyboardNavigator(TransformGroup tg) {
            super(tg);
        }

        public void processStimulus(Enumeration enumeration) {
            System.out.println(enumeration);
            super.processStimulus(enumeration);
        }
    }

}//class CubePanel


class ButtonControlPanel extends JPanel {
    private CubePanel cube;
    private JLabel alphaLabel = new JLabel("a = " + 4000);
    private JLabel scaleLabel = new JLabel("scale = " + .4);

    //--------------------------------------------
    // Sets up the cube control panel
    //--------------------------------------------
    public ButtonControlPanel(CubePanel cubePanel) {
        setLayout(new FlowLayout());
        cube = cubePanel;
        add(alphaLabel);
        add(scaleLabel);

        add(new RunButton("[m") {
            public void run() {
                cube.setAlphaTime(cube.getAlphaTime() - 500);
                alphaLabel.setText("a = " + cube.getAlphaTime());
            }//run
        });

        add(new RunButton("[p") {
            public void run() {
                cube.setAlphaTime(cube.getAlphaTime() + 500);
                alphaLabel.setText("a = " + cube.getAlphaTime());
            }
        });

        add(new RunButton("[s") {
            public void run() {
                cube.setAlphaTime(0);
                alphaLabel.setText("a = " + cube.getAlphaTime());
            }
        });

        add(new RunButton("sm[aller cube") {
            public void run() {
                cube.setCubeSize(cube.getCubeScale() - .1f);
                scaleLabel.setText("scale = " + cube.getCubeScale());
            }
        });

        add(new RunButton("bi[gger cube") {
            public void run() {
                cube.setCubeSize(cube.getCubeScale() + .1f);
                scaleLabel.setText("scale = " + cube.getCubeScale());
            }
        });

    } //end constructor ButtonControlPanel

}//class ButtonControlPanel
